<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-1                                              |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: paloSantoFail2Ban.class.php,v 1.1 2013-06-10 07:10:30 Nikita Rukavkov admin@voip-lab.ru Exp $ */

include_once("/var/www/html/libs/paloSantoDB.class.php");
include_once("/var/www/html/libs/paloSantoConfig.class.php");
include_once("/var/www/html/libs/paloSantoValidar.class.php");
/* Clase que implementa DHCP Server */
class PaloSantoFail2Ban
{
    var $errMsg;
    var $pConfig;
    var $tConfig;
    var $filename_cfg;

    function PaloSantoFail2Ban()
    {
	$this->pConfig = new paloConfig("/var/www/html/modules/anti_hacker/configs","settings.conf"," = ","\s*=\s*");
	$this->tConfig = new paloConfig("/var/www/html/modules/anti_hacker/configs","template.conf"," = ","\s*=\s*");
	$this->filename_cfg = "/var/www/html/modules/anti_hacker/configs/settings.conf";
    }
    
    function load_fail2ban_table($filter_Jail,$filter_IP)
    {
	$ret = split("\n", `/usr/bin/elastix-helper fail2ban --dumpiptables`);

	$rTable=array();

	foreach($ret as $n => $rstr) {
    	    $r = preg_split("/[\s]+/", $rstr);
    	    if(isset($r[3]))
    	    if(preg_match('/^(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)(?:[.](?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)){3}$/',$r[3])) { 
    		$r[1]=str_replace('fail2ban-','',$r[1]);
		$arrTmp[0] = "<input type='checkbox' name='ip[]' value='$r[3],$r[1]' />";
		$need_add = FALSE;
    		if($filter_Jail != '' && $filter_IP != '')
    		    $need_add = ($filter_Jail==$r[1] && $filter_IP==$r[3]) ? TRUE : FALSE;
		else if ($filter_Jail != '')
    		    $need_add = ($filter_Jail==$r[1]) ? TRUE : FALSE;
    		else if ($filter_IP != '')
    		    $need_add = ($filter_IP==$r[3]) ? TRUE : FALSE;
    		else $need_add = TRUE;
		    
		if($need_add) $rTable[] = array($arrTmp[0],$r[3],$r[1]);
	    }    
	}
	return $rTable;
    }


    function getConfigurationFail2Ban() 
    {
        global $arrLang;
    }

    function getStatusServiceFail2Ban()
    {
        $output = $ret = NULL;
        exec('sudo /sbin/service fail2ban status', $output, $ret);
        if(strpos($output[0],'pid')!==FALSE) return 'active';
        else return 'disactive';
    }

    function saveMailTemplate($arrValues)
    {
	setlocale(LC_CTYPE, "en_US.UTF-8");
        $sComando = '/usr/bin/elastix-helper fail2ban --savetemplate'.
                    ' --from "'.escapeshellarg($arrValues['from_mail']).'"'.
                    ' --realname "'.escapeshellarg($arrValues['realname']).'"'.
                    ' --bodystart "'.escapeshellarg($arrValues['bodystart']).'"'.
                    ' --bodystop "'.escapeshellarg($arrValues['bodystop']).'"'.
                    ' --bodyban "'.escapeshellarg($arrValues['bodyban']).'"'.
                    ' --bodyunban "'.escapeshellarg($arrValues['bodyunban']).'"'.
                    ' --titlestart "'.escapeshellarg($arrValues['titlestart']).'"'.
                    ' --titlestop "'.escapeshellarg($arrValues['titlestop']).'"'.
                    ' --titleban "'.escapeshellarg($arrValues['titleban']).'"'.
                    ' --titleunban "'.escapeshellarg($arrValues['titleunban']).'"';

        $output = $ret = NULL;
        exec($sComando, $output, $ret);
        return true;
    }
    function startServiceFail2Ban()
    {
        $this->errMsg = '';
        if(count($this->pConfig->leer_configuracion())>0)
        {
    	    $sComando = '/usr/bin/elastix-helper fail2ban --start 2>&1';
    	    $output = $ret = NULL;
    	    exec($sComando, $output, $ret);
    	    if ($ret != 0) {
        	$this->errMsg = implode('', $output);
        	return FALSE;
    	    }
    	    return TRUE;
    	}
    	else
    	{
    	    $this->errMsg = 'Settings file not found. Please press Update Button to create it.';
    	    return FALSE;
    	}
    }

    function stopServiceFail2Ban()
    {
        $this->errMsg = '';
        $sComando = '/usr/bin/elastix-helper fail2ban --stop 2>&1';
        $output = $ret = NULL;
        exec($sComando, $output, $ret);
        if ($ret != 0) {
            $this->errMsg = implode('', $output);
            return FALSE;
        }
        return TRUE;
    }

    function updateFileConfFail2Ban($arrValues)
    {
	global $arrLang;
        $this->errMsg = '';
        $arrValues['bantime']*=3600;
        $sComando = '/usr/bin/elastix-helper fail2ban --config'.
                    ' --mail '.escapeshellcmd($arrValues['target']).
                    ' --count '.escapeshellcmd($arrValues['count']).
                    ' --bantime '.escapeshellcmd($arrValues['bantime']).
                    ' --monitor '.escapeshellcmd($arrValues['monitor']).
                    ($arrValues['exceptions'] != '' ? ' --exceptions '.escapeshellcmd($arrValues['exceptions']) : '').
                    ($arrValues['websecure'] == 'on' ? ' --web' : '').
                    ($arrValues['sshsecure'] == 'on' ? ' --ssh' : '').
                    ($arrValues['vsftpdsecure'] == 'on' ? ' --vsftpd' : '').
                    ($arrValues['asterisksecure'] == 'on' ? ' --asterisk' : '').
                    ' 2>&1';
        $output = $ret = NULL;
        exec($sComando, $output, $ret);
        if ($ret != 0) {
            $this->errMsg = implode('', $output);
	    return FALSE;
        }
        else
        {
            $this->pConfig->escribir_configuracion($arrValues);
            return TRUE;
        }
    }
    
    function checkService($service)
    {
	$output = $ret = NULL;
	$sComando = '/usr/bin/elastix-helper fail2ban --checkservice'.
    	            ' --table '.escapeshellcmd($service).
                    ' 2>&1';
        
        exec($sComando, $output, $ret);
        if($ret != 0) return FALSE;
        else return $output[0];
    }
    
    function downloadLogsFail2Ban()
    {
	$output = $ret = NULL;
	$sComando = '/usr/bin/elastix-helper fail2ban --ziplogs'.
                    ' 2>&1';
        
        exec($sComando, $output, $ret);
        if($ret != 0) return FALSE;
        else return TRUE;
    }
    

    function removeFromIptables($ip)
    {
	foreach($ip as $comb)
	{
	    $validator = new PaloValidar();
	    $validator->clear();
	    $arrTmp = explode(",",$comb);
	    $ip = $arrTmp[0];
	    $table = $arrTmp[1];
	    if(!in_array($table,array('asterisk','ssh','https','vsftpd'))) continue;
	    if(!$validator->validar("IP address",$ip,"ip")) continue;
	    exec("/usr/bin/elastix-helper fail2ban --removefromiptables --table ".escapeshellarg($table)." --ip ".escapeshellarg($ip),$output,$ret);
	}
    }
    function moveLicense($file_lic)
    {
	if(file_exists($file_lic))
	{
    	    exec("/usr/bin/elastix-helper fail2ban --movelicense --filelic ".escapeshellarg($file_lic),$output,$ret);
    	    if(file_exists('/var/www/html/modules/anti_hacker/configs/anti-hacker.lic')) return TRUE;
    	    else return FALSE;
    	}
    	else
    	    return FALSE;
    }
    

    function loadSettings($param=FALSE)
    {
        $settings = $this->pConfig->leer_configuracion($param);
	$arrValues['bantime'] = $this->pConfig->privado_get_valor($settings,"bantime")/3600;
	$arrValues['count'] = $this->pConfig->privado_get_valor($settings,"count");
        $arrValues['target'] =  $this->pConfig->privado_get_valor($settings,"target");
	$arrValues['exceptions'] = $this->pConfig->privado_get_valor($settings,"exceptions");
	$arrValues['monitor'] = $this->pConfig->privado_get_valor($settings,"monitor");
	$arrValues['asterisksecure'] = $this->pConfig->privado_get_valor($settings,"asterisksecure");
        $arrValues['websecure'] = $this->pConfig->privado_get_valor($settings,"websecure");
	$arrValues['sshsecure'] = $this->pConfig->privado_get_valor($settings,"sshsecure");
	$arrValues['vsftpdsecure'] = $this->pConfig->privado_get_valor($settings,"vsftpdsecure");
	return $arrValues;
    }

    function loadSettingsTemplate($param=FALSE)
    {
        $settings = $this->tConfig->leer_configuracion($param);
        $arrValues = array();
	$arrValues['from_mail'] = $this->tConfig->privado_get_valor($settings,"from_mail");
	$arrValues['realname'] = $this->tConfig->privado_get_valor($settings,"realname");
	$arrValues['titlestart'] = $this->tConfig->privado_get_valor($settings,"titlestart");
	$arrValues['titlestop'] = $this->tConfig->privado_get_valor($settings,"titlestop");
	$arrValues['titleban'] = $this->tConfig->privado_get_valor($settings,"titleban");
	$arrValues['titleunban'] = $this->tConfig->privado_get_valor($settings,"titleunban");
	$arrValues['bodystart'] = str_replace("<br />","",$this->tConfig->privado_get_valor($settings,"bodystart"));
	$arrValues['bodystop'] = str_replace("<br />","",$this->tConfig->privado_get_valor($settings,"bodystop"));
	$arrValues['bodyban'] = str_replace("<br />","",$this->tConfig->privado_get_valor($settings,"bodyban"));
	$arrValues['bodyunban'] = str_replace("<br />","",$this->tConfig->privado_get_valor($settings,"bodyunban"));
	return $arrValues;
    }

    function checkInstall($namePackage)
    {
    	global $arrLang;
    	$this->errMsg = '';
	exec("rpm -q $namePackage",$respuesta,$retorno);
	if($retorno == 0){
	    return TRUE;
	}
	else{
	    return FALSE;
	}
    }
    
    function checkTables()
    {
	global $arrLang;
    	$this->errMsg = '';

	if($this->getStatusServiceFail2Ban()=="active")
	{
	    global $arrLang;
    	    $this->errMsg = '';
	    $settings=$this->loadSettings();
	    if($settings['websecure'] == 'on')
	    {
		$sComando = '/usr/bin/elastix-helper fail2ban --checkjails --table https 2>&1';
    		$output = $ret = NULL;
    		exec($sComando, $output, $ret);
    		if ($ret != 0 && $ret!=2) {
        	    $this->errMsg .='WEB-GUI,';
		}
	    }

	    if($settings['asterisksecure'] == 'on')
	    {
		$sComando = '/usr/bin/elastix-helper fail2ban --checkjails --table asterisk 2>&1';
    		$output = $ret = NULL;
    		exec($sComando, $output, $ret);
//    		if ($ret != 0 && $ret != 2) {
		if ($ret != 0 && $ret!=2) {

        	    $this->errMsg .='ASTERISK,';
		}
	    }
	    
	    if($settings['sshsecure'] == 'on')
	    {
		$sComando = '/usr/bin/elastix-helper fail2ban --checkjails --table ssh 2>&1';
    		$output = $ret = NULL;
    		exec($sComando, $output, $ret);
    		if ($ret != 0 && $ret!=2) {
        	    $this->errMsg .='SSH,';
		}
	    }

	    if($settings['vsftpdsecure'] == 'on')
	    {
		$sComando = '/usr/bin/elastix-helper fail2ban --checkjails --table vsftpd 2>&1';
    		$output = $ret = NULL;
    		exec($sComando, $output, $ret);
    		if ($ret != 0 && $ret!=2) {
        	    $this->errMsg .='VSFTPD,';
		}
	    }
	    
	    if($this->errMsg!='') 
	    {
		$this->errMsg = substr_replace($this->errMsg, "", -1);
		return FALSE;
	    }

	}
	return TRUE;
    }
    
    function reportToEmailFail2Ban($err_jails)
    {
	$output = $ret = $message = NULL;
	$settings = $this->pConfig->leer_configuracion(FALSE);
	
	exec("/bin/hostname",$output);
	$hostname = $output[0];
	$sender = 'fail2ban@'.$hostname;
	
    	$dest = $this->pConfig->privado_get_valor($settings,"target");
    	
    	if($dest == '' || $err_jails == '') return FALSE;
    	
    	if($err_jails == "just_test")
	    $message = 	"printf %b 'Subject: [Fail2Ban] ANTIHACKER TEST MAIL\n".
			"From: Fail2Ban <$sender>\n".
			"To: $dest\n".
			"Hi,\n\n".
			"This is a test message from server $hostname. Please do not reply to this email.\n\n".
			"Regards,\n".
			"Fail2Ban and AntiHacker' | /usr/sbin/sendmail -f $sender $dest";
    	else
	    $message = "printf %b 'Subject: [Fail2Ban] WARNING: $err_jails \n".
			"From: Fail2Ban <$sender>\n".
			"To: $dest\n".
			"Hi,\n\n".
			"The jails $err_jails has been stopped.  It causes if you change port for service(s) $err_jails or activate/deactivate firewall. \n".
			"Please open the AntiHacker settings page and press UPDATE button to fix it!\n".
			"Server: $hostname.\n\n".
			"Regards,\n".
			"Fail2Ban and AntiHacker' | /usr/sbin/sendmail -f $sender $dest";
    	exec($message,$output,$ret);
    	if ($ret != 0) return FALSE;
	else return TRUE;
	
    }
}
?>
